<!DOCTYPE html>
<html>

<head>

<meta charset="UTF-8">
<meta name=viewport content="width=device-width, initial-scale=1">


<title>Drill 0.9 Released - Apache Drill</title>

<link href="//maxcdn.bootstrapcdn.com/font-awesome/4.3.0/css/font-awesome.min.css" rel="stylesheet" type="text/css"/>
<link href='//fonts.googleapis.com/css?family=PT+Sans' rel='stylesheet' type='text/css'/>
<link href="/css/site.css" rel="stylesheet" type="text/css"/>

<link rel="shortcut icon" href="/favicon.ico" type="image/x-icon"/>
<link rel="icon" href="/favicon.ico" type="image/x-icon"/>

<script src="//ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js" language="javascript" type="text/javascript"></script>
<script src="//cdnjs.cloudflare.com/ajax/libs/jquery-easing/1.3/jquery.easing.min.js" language="javascript" type="text/javascript"></script>
<script language="javascript" type="text/javascript" src="/js/modernizr.custom.js"></script>
<script language="javascript" type="text/javascript" src="/js/script.js"></script>
<script language="javascript" type="text/javascript" src="/js/drill.js"></script>

</head>


<body onResize="resized();">
  <div class="page-wrap">
    <div class="bui"></div>

<div id="menu" class="mw">
<ul>
  <li class='toc-categories'>
  <a class="expand-toc-icon" href="javascript:void(0);"><i class="fa fa-bars"></i></a>
  </li>
  <li class="logo"><a href="/"></a></li>
  <li class='expand-menu'>
  <a href="javascript:void(0);"><span class='menu-text'>Menu</span><span class='expand-icon'><i class="fa fa-bars"></i></span></a>
  </li>
  <li class='clear-float'></li>
  <li class="documentation-menu">
    <a href="/docs/">Documentation</a>
    <ul>
      
        <li><a href="/docs/getting-started/">Getting Started</a></li>
      
        <li><a href="/docs/architecture/">Architecture</a></li>
      
        <li><a href="/docs/tutorials/">Tutorials</a></li>
      
        <li><a href="/docs/install-drill/">Install Drill</a></li>
      
        <li><a href="/docs/configure-drill/">Configure Drill</a></li>
      
        <li><a href="/docs/connect-a-data-source/">Connect a Data Source</a></li>
      
        <li><a href="/docs/odbc-jdbc-interfaces/">ODBC/JDBC Interfaces</a></li>
      
        <li><a href="/docs/query-data/">Query Data</a></li>
      
        <li><a href="/docs/performance-tuning/">Performance Tuning</a></li>
      
        <li><a href="/docs/log-and-debug/">Log and Debug</a></li>
      
        <li><a href="/docs/sql-reference/">SQL Reference</a></li>
      
        <li><a href="/docs/data-sources-and-file-formats/">Data Sources and File Formats</a></li>
      
        <li><a href="/docs/develop-custom-functions/">Develop Custom Functions</a></li>
      
        <li><a href="/docs/troubleshooting/">Troubleshooting</a></li>
      
        <li><a href="/docs/developer-information/">Developer Information</a></li>
      
        <li><a href="/docs/release-notes/">Release Notes</a></li>
      
        <li><a href="/docs/sample-datasets/">Sample Datasets</a></li>
      
        <li><a href="/docs/archived-pages/">Archived Pages</a></li>
      
        <li><a href="/docs/progress-reports/">Progress Reports</a></li>
      
        <li><a href="/docs/project-bylaws/">Project Bylaws</a></li>
      
    </ul>
  </li>
  <li class='nav'>
    <a href="/community-resources/">Community</a>
    <ul>
      <li><a href="/team/">Team</a></li>
      <li><a href="/mailinglists/">Mailing Lists</a></li>
      <li><a href="/community-resources/">Community Resources</a></li>
    </ul>
  </li>
  <li class='nav'><a href="/faq/">FAQ</a></li>
  <li class='nav'><a href="/blog/">Blog</a></li>
  <li id="twitter-menu-item"><a href="https://twitter.com/apachedrill" title="apachedrill on twitter" target="_blank"><img src="/images/twitter_32_26_white.png" alt="twitter logo" align="center"></a> </li>
  <li class='search-bar'>
    <form id="drill-search-form">
      <input type="text" placeholder="Search Apache Drill" id="drill-search-term" />
      <button type="submit">
        <i class="fa fa-search"></i>
      </button>
    </form>
  </li>
  <li class="d">
    <a href="/download/">
      <i class="fa fa-cloud-download"></i> Download
    </a>
  </li>
</ul>
</div>

    <link href="/css/content.css" rel="stylesheet" type="text/css">

<div class="post int_text">
  <header class="post-header">
    <div class="int_title">
      <h1 class="post-title">Drill 0.9 Released</h1>
    </div>
    <p class="post-meta">
    
    <strong>Authors:</strong>
    <ul>
      
        
        <li>Tomer Shiran (Founder, PMC Member and Committer, Apache Drill)</li>
      
        
        <li>Jacques Nadeau (PMC Chair and Committer, Apache Drill)</li>
      
    </ul>
    
<strong>Date:</strong> May 4, 2015
</p>
  </header>
  <div class="addthis_sharing_toolbox"></div>

  <article class="post-content">
    <p>It has been about a month since the release of Drill 0.8, which included <a href="/blog/drill-0.8-released/">more than 240 improvements</a>. Today we&#39;re happy to announce the availability of Drill 0.9, providing additional enhancements and bug fixes. In fact, this release includes <a href="https://issues.apache.org/jira/secure/ReleaseNote.jspa?projectId=12313820&amp;version=12328813">200 resolved JIRAs</a>. Some of the noteworthy features in Drill 0.9 are:</p>

<ul>
<li><strong>Authentication</strong> (<a href="https://issues.apache.org/jira/browse/DRILL-2674">DRILL-2674</a>). Drill now supports username/password authentication through the Java and C++ clients, as well as JDBC and ODBC. On the server-side, Drill leverages Linux PAM to securely validate the credentials. Users can choose to use an external user directory such as Active Directory or LDAP. To enable authentication, set the <code>security.user.auth</code> option in <code>drill-override.conf</code>.</li>
<li><strong>Impersonation</strong> (<a href="https://issues.apache.org/jira/browse/DRILL-2363">DRILL-2363</a>). Queries now execute and access resources using the identity of the user who submitted the query. Previously, all queries would run as the same user (eg, <code>drill</code>). With the new impersonation capability, the query will fail if the submitting user does not have permission to read the requested file(s) in the distributed file system. To enable impersonation, set the <code>drill.exec.impersonation</code> option in <code>drill-override.conf</code>.</li>
<li><strong>Ownership chaining</strong>. Drill now allows views with different owners to be chained. This represents a very flexible access control solution. For example, an administrator with access to raw, sensitive data could create a view called <code>masked</code> which would expose only a subset of the data to other users. The administrator would enable users to read the <code>masked</code> view but not the raw data. Note that Drill provides an option <code>max_chained_user_hops</code> that specifies how many ownership changed are allowed in a chain, thereby providing administrators (or data stewards) more control over sharing of data.</li>
<li><strong>MongoDB authentication</strong> (<a href="https://issues.apache.org/jira/browse/DRILL-1502">DRILL-1502</a>). Drill can now connect to a MongoDB cluster that requires authentication.</li>
<li><strong>Extended JSON datatypes</strong>. Our friends at MongoDB invented <a href="http://docs.mongodb.org/manual/reference/mongodb-extended-json/">extended JSON</a> - a set of extensions to the JSON format for supporting additional data types. We decided to embrace extended JSON in Drill. For example, standard JSON doesn&#39;t have a time type, so a time could be represented as either a string or a number: <code>{&quot;foo&quot;: &quot;19:20:30.450Z&quot;}</code> is just a string. With extended JSON, the <code>$time</code> qualifier can be used to specify that <code>foo</code> is a time <code>{&quot;foo&quot;: {&quot;$time&quot;: &quot;19:20:30.450Z&quot;}}</code>.
We now support a number of qualifiers including <code>$bin</code>, <code>$date</code>, <code>$time</code>, <code>$interval</code>, <code>$numberLong</code> and <code>$dateDay</code> (see <a href="https://github.com/apache/drill/blob/master/exec/java-exec/src/test/resources/vector/complex/extended.json">the example</a>). We&#39;re in the process of adding some additional qualifiers to make sure that all of MongoDB&#39;s extended types are supported (this is particularly important when querying data in MongoDB).</li>
<li><strong>Avro support</strong> (<a href="https://issues.apache.org/jira/browse/DRILL-1512">DRILL-1512</a>). Drill can now read Avro files. This patch was contributed by Andrew Selden at Elastic.co (formerly known as Elasticsearch).</li>
<li><strong>Improved error messages</strong> (<a href="https://issues.apache.org/jira/browse/DRILL-2675">DRILL-2675</a> and more). It can be challenging for a complex distributed system like Drill to translate low-level internal conditions into actionable messages to the user. This release includes several enhancements that enable Drill to accomplish just that in a variety of cases.</li>
<li><strong>Parquet and Calcite enhancements</strong> (<a href="https://issues.apache.org/jira/browse/DRILL-1410">DRILL-1410</a> and <a href="https://issues.apache.org/jira/browse/DRILL-1384">DRILL-1384</a>). Drill isn&#39;t a traditional query engine - it&#39;s the first analytical query engine with a JSON data model. This has required us to enhance Parquet (our columnar format) and Calcite (our SQL parser). These enhancements have now been contributed back to those projects, and Drill is using the latest versions which include these enhancements.</li>
<li><p><strong>New sys tables for memory and thread information</strong> (<a href="https://issues.apache.org/jira/browse/DRILL-2275">DRILL-2275</a>). Drill includes two new <code>sys</code> tables that provide real-time metrics about memory utilization and threads on each of the nodes in the cluster. You can run a simple <code>SELECT *</code> to see what information is available:</p>
<div class="highlight"><pre><code class="language-sql" data-lang="sql"><span class="k">SELECT</span> <span class="o">*</span> <span class="k">FROM</span> <span class="n">sys</span><span class="p">.</span><span class="n">drillmemory</span><span class="p">;</span>
<span class="k">SELECT</span> <span class="o">*</span> <span class="k">FROM</span> <span class="n">sys</span><span class="p">.</span><span class="n">drillbitthreads</span><span class="p">;</span>
</code></pre></div></li>
<li><p><strong>Support for very wide tables</strong> (<a href="https://issues.apache.org/jira/browse/DRILL-2739">DRILL-2739</a>). Drill previously had some issues with tables that had more than 4095 colums. This limitation has been addressed.</p></li>
</ul>

<p>You can now <a href="/download/">download Drill 0.9</a>. As always, you can check out the official <a href="/docs/release-notes/">release notes</a> for more details.</p>

<p>We&#39;re gearing up for Drill&#39;s 1.0 release later this month. Stay tuned!</p>

<p>Happy Drilling!<br>
Tomer Shiran and Jacques Nadeau</p>

  </article>
 <div id="disqus_thread"></div>
    <script type="text/javascript">
        /* * * CONFIGURATION VARIABLES: EDIT BEFORE PASTING INTO YOUR WEBPAGE * * */
        var disqus_shortname = 'drill'; // required: replace example with your forum shortname

        /* * * DON'T EDIT BELOW THIS LINE * * */
        (function() {
            var dsq = document.createElement('script'); dsq.type = 'text/javascript'; dsq.async = true;
            dsq.src = '//' + disqus_shortname + '.disqus.com/embed.js';
            (document.getElementsByTagName('head')[0] || document.getElementsByTagName('body')[0]).appendChild(dsq);
        })();
    </script>
    <noscript>Please enable JavaScript to view the <a href="http://disqus.com/?ref_noscript">comments powered by Disqus.</a></noscript>
    
</div>
<script type="text/javascript" src="//s7.addthis.com/js/300/addthis_widget.js#pubid=ra-548b2caa33765e8d" async="async"></script>

  </div>
  <p class="push"></p>
<div id="footer" class="mw">
<div class="wrapper">
Copyright © 2012-2014 The Apache Software Foundation, licensed under the Apache License, Version 2.0.<br>
Apache and the Apache feather logo are trademarks of The Apache Software Foundation. Other names appearing on the site may be trademarks of their respective owners.<br/><br/>
</div>
</div>

  <script>
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
(i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
})(window,document,'script','//www.google-analytics.com/analytics.js','ga');

ga('create', 'UA-53379651-1', 'auto');
ga('send', 'pageview');
</script>

</body>
</html>
